package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingRutaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingRuta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.GP_PricingRutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingRutaService")
public class GP_PricingRutaServiceImpl implements GP_PricingRutaService {

	@Autowired
	private GP_PricingRutaDAO pricingRutaDAO;

	public List<GP_PricingRuta> obtenerTodos() {
		return pricingRutaDAO.obtenerTodos();
	}

	public GP_PricingRuta obtenerID(Integer id) {
		return pricingRutaDAO.obtenerID(id);
	}

	@Transactional
	public GP_PricingRuta suscribir(GP_PricingRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingRutaDAO.suscribir(entidad);
	}

	@Transactional
	public GP_PricingRuta actualizacion(GP_PricingRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingRutaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GP_PricingRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.EXCLUIDO);

		pricingRutaDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingRuta(GP_Pricing pricing, Ruta ruta) {
		return pricingRutaDAO.obtenerPricingRuta(pricing, ruta);
	}

	@Override
	public List<GP_PricingRuta> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingRutaDAO.obtenerTodoPorPricing(pricing);
	}
}
